function varargout = observerMotionGUI(varargin)
% OBSERVERMOTIONGUI MATLAB code for observerMotionGUI.fig
%      OBSERVERMOTIONGUI, by itself, creates a new OBSERVERMOTIONGUI or raises the existing
%      singleton*.
%
%      H = OBSERVERMOTIONGUI returns the handle to a new OBSERVERMOTIONGUI or the handle to
%      the existing singleton*.
%
%      OBSERVERMOTIONGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in OBSERVERMOTIONGUI.M with the given input arguments.
%
%      OBSERVERMOTIONGUI('Property','Value',...) creates a new OBSERVERMOTIONGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before observerMotionGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to observerMotionGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help observerMotionGUI

% Last Modified by GUIDE v2.5 05-Oct-2016 18:21:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @observerMotionGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @observerMotionGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before observerMotionGUI is made visible.
function observerMotionGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to observerMotionGUI (see VARARGIN)

% initialize observer motion parameters
handles.Tx = 0.0;
handles.Ty = 0.0;
handles.Tz = 0.0;
handles.Rx = 0.0;
handles.Ry = 0.0;
handles.Rz = 0.0;
handles.Zin = 1.0;      % depth of inner square region
handles.Zout = 2.0;     % depth of surrounding region
% create a dense depth map
handles.zmap = 2 * ones(200,200);
handles.zmap(50:150, 50:150) = 1.0;
axis([-10 210 -10 210])
set(gca, 'XTick', 0:20:200, 'YTick', 0:20:200, 'XTickLabel', -5:5, 'YTickLabel', -5:5)

% Choose default command line output for observerMotionGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes observerMotionGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = observerMotionGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on slider movement.
function txslider_Callback(hObject, eventdata, handles)
% hObject    handle to txslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Tx = (12 * get(hObject, 'Value')) - 6.0;
set(handles.TxText, 'String', num2str(handles.Tx));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function txslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function tzslider_Callback(hObject, eventdata, handles)
% hObject    handle to tzslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Tz = 4 * get(hObject, 'Value');
set(handles.TzText, 'String', num2str(handles.Tz));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function tzslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tzslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function rxslider_Callback(hObject, eventdata, handles)
% hObject    handle to rxslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Rx = (0.5 * get(hObject, 'Value')) - 0.25;
set(handles.RxText, 'String', num2str(handles.Rx));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function rxslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rxslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function tyslider_Callback(hObject, eventdata, handles)
% hObject    handle to tyslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Ty = (12 * get(hObject, 'Value')) - 6.0;
set(handles.TyText, 'String', num2str(handles.Ty));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function tyslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tyslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function ryslider_Callback(hObject, eventdata, handles)
% hObject    handle to ryslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Ry = (0.5 * get(hObject, 'Value')) - 0.25;
set(handles.RyText, 'String', num2str(handles.Ry));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function ryslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ryslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function z1slider_Callback(hObject, eventdata, handles)
% hObject    handle to z1slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Zout = 2 + (2 * get(hObject, 'Value'));
handles.zmap = handles.Zout * ones(200,200);
handles.zmap(50:150, 50:150) = handles.Zin;
set(handles.ZoutText, 'String', num2str(handles.Zout));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function z1slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to z1slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function rzslider_Callback(hObject, eventdata, handles)
% hObject    handle to rzslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Rz = (1 * get(hObject, 'Value')) - 0.5;
set(handles.RzText, 'String', num2str(handles.Rz));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function rzslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rzslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function z0slider_Callback(hObject, eventdata, handles)
% hObject    handle to z0slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.Zin = 1 + (1.0 * get(hObject, 'Value'));
handles.zmap(50:150, 50:150) = handles.Zin;
set(handles.ZinText, 'String', num2str(handles.Zin));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function z0slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to z0slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on button press in displayButton.
function displayButton_Callback(hObject, eventdata, handles)
% hObject    handle to displayButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[handles.vx, handles.vy, xfoe, yfoe] = setupImageVelocities(handles.Tx, handles.Ty, ...
         handles.Tz, handles.Rx, handles.Ry, handles.Rz, handles.zmap);
if (abs(xfoe) <= 5.0) && (abs(yfoe) <= 5.0)
    displayVelocityField(handles.vx, handles.vy, 10, 100+(xfoe*20), 100+(yfoe*20));
    set(handles.msgText, 'String', '')
else
    displayVelocityField(handles.vx, handles.vy, 10);
    set(handles.msgText, 'String', 'true FOE out of bounds')
end
axis equal
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in closeButton.
function closeButton_Callback(hObject, eventdata, handles)
% hObject    handle to closeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete(handles.figure1)

% --- Executes on button press in foeButton.
function foeButton_Callback(hObject, eventdata, handles)
% hObject    handle to foeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[xhead, yhead, dvx, dvy] = computeObserverMotion(handles.vx, handles.vy);
% disp(['xhead ' num2str(xhead) ' yhead ' num2str(yhead)])
if (abs(xhead) <= 5.0) && (abs(yhead) <= 5.0) && (handles.Tz > 0)
    hold on
    scatter(100+(xhead*20), 100+(yhead*20), 100, 'g', 'LineWidth', 2);
    displayDifferenceVectors(dvx, dvy)
    hold off
    set(handles.msgText, 'String', '')
elseif (sum(sum(dvx)) == 0) && (sum(sum(dvy)) == 0)
    set(handles.msgText, 'String', 'no large velocity differences')
else
    set(handles.msgText, 'String', 'computed FOE out of bounds')
end
